require 'rails_helper'

RSpec.describe Hermes::UpdateSubscription, type: :model do
  let!(:admin) { create(:user, roles: ['Administrator'])}
  let!(:tagset) { create(:tagset,)}


  describe 'generate_reporting_CSV' do
    4.times do |i|
      let!("hr#{i}".to_sym) {create(:complete_request)}
      let!("entity#{i}".to_sym) { create(:entity, title: "entity#{i}", siret: "1234567890111#{i}", id_cristal: i)}
    end 

    it 'works' do
      4.times do |i|
        eval("hr#{i}").main_applicant.update(main_employer_siret: eval("entity#{i}").siret)
        eval("hr#{i}").user.subscription.subscribe_to_email("user.new_reserved_offer")
      end 

      hr3.user.subscription.unsubscribe_to_email("user.new_reserved_offer")

      doc = Hermes::UpdateSubscription.generate_reporting_CSV(
        tagset_batch_id: tagset.id,
        responsible_id:  admin.id,
      )
      table = CSV.parse(File.read(doc.file.filename), headers: true, col_sep:  ";" )
      expect(table.count).to eq(3)
      expect(table.first['entity_title']).to eq('entity0')

      File.delete(doc.file.filename)
    end 
  end

end
